#include "Transfer85.h"
extern HANDLE hPort;
//extern ofstream logfile;
extern HWND hDlg;

/*
   White wire - RTS/DSR (2)
   Red wire   - DTR/CTS (1)
*/


byte getport() {
   DWORD stat;
   byte b;
   if (!GetCommModemStatus(hPort, &stat))
      MessageBox(hDlg, "There was an error calling GetCommModemStatus", "Transfer-85", MB_OK);
   b = (stat & MS_CTS_ON ? 1:0) + (stat & MS_DSR_ON ? 2:0);
   return b;
}

void setport(byte b) {
   EscapeCommFunction(hPort, (b & 2) ? SETRTS : CLRRTS);
   EscapeCommFunction(hPort, (b & 1) ? SETDTR : CLRDTR);
}

void SendByte(byte b) {
   byte bits, byt = b;
   for (bits = 1; bits <=8; bits++) {
      if (b & 1) setport(2);
      else setport(1);
      while (getport() != 0) ;
      setport(3);
      while (getport() != 3) ;
      b >>= 1;
   }
//   logfile << ' ' << hex << (int)byt << dec;
//   logfile.flush();
}

byte RecvByte() {
   byte curbit = 1;
   byte byt = 0, bits, x;

   for (bits = 1; bits <= 8; bits++) {
      while ((x = getport()) == 3);
      if (x == 1) {
         byt += curbit;
         setport(1);
         x = 2;
      } else {
         setport(2);
         x = 1;
      }
      while ((getport() & x) == 0);
      setport(3);
      curbit <<= 1;
   }
//   logfile << ' ' << hex << (int)byt << dec;
//   logfile.flush();
   return byt;
}
